<?php
/*
Plugin Name: Get Recent Comments
Version: 0.8
Plugin URI: http://blog.jodies.de/archiv/2004/11/13/recent-comments/
Author: Krischan Jodies
Author URI: http://blog.jodies.de
Description: Display the most recent comments with your own formatting in the sidebar


*/

function get_recent_comments ($max_comments=5,
                              $max_characters_per_comment=120,
                              $format='<li><a href="%comment_link" title="%post_title, %post_date">%comment_author</a>: %comment_excerpt</li>')
{
	global $wpdb,$tablecomments,$tableposts;
	$query = "SELECT * FROM $tablecomments ".
                 "LEFT JOIN $tableposts ON $tableposts.ID=$tablecomments.comment_post_ID ".
                 "WHERE post_status = 'publish' AND comment_approved= '1' AND  post_password = '' ".
                 "ORDER BY comment_date DESC LIMIT $max_comments";

	$comments = $wpdb->get_results($query);
        
	foreach ($comments as $comment)
	{
		$comment_excerpt = strip_tags($comment->comment_content);
		$comment_excerpt = preg_replace("/[\n\t\r]/"," ",$comment_excerpt);
		$comment_excerpt = preg_replace("/\s{2}/"," ",$comment_excerpt);
		$comment_excerpt = preg_replace("/([^\s]{30})/","$1 ",$comment_excerpt);
		$word = strtok($comment_excerpt," ");
		$comment_excerpt = "";
		while ($word) {
			if (strlen($comment_excerpt . " $word") > 
                            $max_characters_per_comment) {
				$comment_excerpt = trim($comment_excerpt);
				$comment_excerpt .= "...";
				break;
			}
			$comment_excerpt .= " $word";
			$word = strtok(" ");
		}
		
		$post_link    = get_permalink($comment->comment_post_ID);
		$comment_link = $post_link .
				"#comment-$comment->comment_ID";
		$comment_date = mysql2date(get_settings('date_format'),$comment->comment_date);
		$comment_author = $comment->comment_author;
		if (! $comment_author) $comment_author = 'Anonymous';
		$post = get_postdata($comment->comment_post_ID);
		$post_date = mysql2date(get_settings('date_format'),$post['Date']);

		$output = $format;
		$output = preg_replace("/%comment_excerpt/", $comment_excerpt,$output);
		$output = preg_replace("/%comment_link/",    $comment_link,   $output);
		$output = preg_replace("/%comment_author/",  $comment_author, $output);
		$output = preg_replace("/%comment_date/",    $comment_date,   $output);
		$output = preg_replace("/%post_title/",      
                                       htmlspecialchars(stripslashes($post['Title'])), $output);
		$output = preg_replace("/%post_link/",       $post_link,      $output);
		$output = preg_replace("/%post_date/",       $post_date,      $output);

echo "\t$output\n"; 
	}
}

?>
