<?php
/*
Plugin Name: Get Recent Comments
Version: 0.9
Plugin URI: http://blog.jodies.de/archiv/2004/11/13/recent-comments/
Author: Krischan Jodies
Author URI: http://blog.jodies.de
Description: Display the most recent comments or trackbacks with your own formatting in the sidebar. Visit Options/Recent Comments after activation of the plugin.

Revision: $Rev: 1214 $
Date: $Date: 2005-03-20 02:14:25 +0000 (Sun, 20 Mar 2005) $
*/

if (function_exists("is_plugin_page") && is_plugin_page()) {
	if (isset($_GET['updated']) && ($_GET['updated'] == 'true') && 
		(!empty($_POST['max_comments'])) && 
		(!empty($_POST['chars_per_comment'])) &&         
		(!empty($_POST['chars_per_word'])) && 
		(!empty($_POST['format'])) &&
		(!empty($_POST['function'])) )
	{
		$function = $_POST['function'];
		if (($function == 'grc') ||
		    ($function == 'grt'))
		{
			if (!empty($_POST['reset_template'])) {
				delete_option('kjgrc_'.$function.'_format');
			} else {
				update_option('kjgrc_'.$function.'_max_comments', (int)$_POST['max_comments']);
				update_option('kjgrc_'.$function.'_chars_per_comment', (int)$_POST['chars_per_comment']);
				update_option('kjgrc_'.$function.'_chars_per_word', (int)$_POST['chars_per_word']);
				update_option('kjgrc_'.$function.'_format', $_POST['format']);
			}
		} else { echo "unknow function"; }
	}
?>   
<div class="wrap">
<h2><?php _e('Options for Get Recent Comments Plugin') ?></h2>

<form method=post action="<?php echo $_SERVER['PHP_SELF']; ?>?page=get-recent-comments.php&amp;updated=true#grc">
   <input type="hidden" name="function" value="grc">
   <fieldset class="options"> 
   <legend id="grc"><?php _e('Recent Comments') ?></legend> 
   <table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr valign="top">
      <th width="33%" scope="row"><?php _e('Show the most recent:') ?></th>
      <td nowrap><input name="max_comments" type="text" id="max_comments" value="<?php echo kjgrc_get_option("grc","max_comments"); ?>" size="3" /> <?php _e('comments') ?></td>
      <td rowspan="3"><pre><div style='font-size: 10px; border-left: 1px solid; margin: 0px;'> %comment_excerpt - Shortened comment.
 %comment_link    - Link to the comment. 
 %comment_author  - Name left by the commenter
 %comment_date    - Date of comment
 %comment_time    - Time of comment
 %author_url      - URL of author or trackback
 %post_title      - Title of the posting
 %post_link       - Link to the posting 
 %post_date       - Date of the posting</pre></div></td>
	</tr>
      <tr valign="top">
      <th width="33%" scope="row"><?php _e('Long comments are chopped off at:') ?></th>
      <td nowrap><input name="chars_per_comment" type="text" id="chars_per_comment" value="<?php echo kjgrc_get_option("grc","chars_per_comment"); ?>" size="3" /> <?php _e('characters') ?></td>
      </tr>
      <tr valign="top">
      <th width="33%" scope="row"><?php _e('Wrap long words at:') ?></th>
      <td nowrap><input name="chars_per_word" type="text" id="chars_per_word" value="<?php echo kjgrc_get_option("grc","chars_per_word"); ?>" size="3" /> <?php _e('characters') ?></td>
      </tr>
      <tr valign="top">
      <th width="33%" scope="row">Template:
      <td>&nbsp;</td>
      </tr>
      <tr valign="top">
      <td colspan="3">
               <textarea name="format" cols="60" rows="2" id="format" style="width: 98%; font-size: 12px;" class="code"><?php echo stripslashes(htmlspecialchars(kjgrc_get_option("grc","format"))); ?></textarea><br />
      <fieldset>
      <legend>Result</legend>
      <span class="code"><?php $result = get_recent_comments(1,1,"",1); echo htmlspecialchars(stripslashes($result)); ?></span>
      </fieldset>
      </td>         
      </tr>
   </table>
   <p class="submit">
   <input type="submit" id="deletepost" name="reset_template" value="<?php _e('Reset template to default') ?> &raquo;" onclick="return confirm('You are about to reset your template for \'Recent Comments\'.\n  \'Cancel\' to stop, \'OK\' to delete.')" />
   <input type="submit" name="Submit" value="<?php _e('Update Recent Comments Options') ?> &raquo;" />
   </p>
   </fieldset>
</form>

<form method=post action="<?php echo $_SERVER['PHP_SELF']; ?>?page=get-recent-comments.php&amp;updated=true#grt">
   <input type="hidden" name="function" value="grt">
   <fieldset class="options"> 
   <legend id="grt"><?php _e('Recent Trackbacks') ?></legend> 
   <table width="100%" cellspacing="2" cellpadding="5" class="editform">
      <tr valign="top">
      <th width="33%" scope="row"><?php _e('Show the most recent:') ?></th>
      <td nowrap><input name="max_comments" type="text" id="max_comments" value="<?php echo kjgrc_get_option("grt","max_comments"); ?>" size="3" /> <?php _e('Trackbacks') ?></td>
      <td rowspan="3"><pre><div style='font-size: 10px; border-left: 1px solid; margin: 0px;'> %comment_excerpt - Shortened comment.
 %comment_link    - Link to the comment.
 %comment_author  - Name left by the commenter
 %comment_date    - Date of comment
 %comment_time    - Time of comment
 %author_url      - URL of author or trackback
 %trackback_title - Title of trackback
 %post_title      - Title of the posting
 %post_link       - Link to the posting
 %post_date       - Date of the posting</pre></div></td>
      </tr>
      <tr valign="top">
      <th width="33%" scope="row"><?php _e('Long trackbacks are chopped off at:') ?></th>
      <td nowrap><input name="chars_per_comment" type="text" id="chars_per_comment" value="<?php echo kjgrc_get_option("grt","chars_per_comment"); ?>" size="3" /> <?php _e('characters') ?></td>
      </tr>
      <tr valign="top">
      <th width="33%" scope="row"><?php _e('Wrap long words at:') ?></th>
      <td><input name="chars_per_word" type="text" id="chars_per_word" value="<?php echo kjgrc_get_option("grt","chars_per_word"); ?>" size="3" /> <?php _e('characters') ?></td>
      </tr>
      <tr valign="top">
      <th width="33%" scope="row">Template:
      <td>&nbsp;</td>
      </tr>
      <tr valign="top">
      <td colspan="3">
               <textarea name="format" cols="60" rows="2" id="format" style="width: 98%; font-size: 12px;" class="code"><?php echo stripslashes(htmlspecialchars(kjgrc_get_option("grt","format"))); ?></textarea><br />
      <fieldset>
      <legend>Result</legend>
      <span class="code"><?php $result = get_recent_trackbacks(1); echo htmlspecialchars(stripslashes($result)); ?></span>
      </fieldset>
      </td>         
      </tr>
   </table>
   <p class="submit">
   <input type="submit" id="deletepost" name="reset_template" value="<?php _e('Reset template to default') ?> &raquo;" onclick="return confirm('You are about to reset your template for \'Recent Trackbacks\'.\n  \'Cancel\' to stop, \'OK\' to delete.')" />
<input type="submit" name="Submit" value="<?php _e('Update Recent Trackbacks Options') ?> &raquo;" />
   </p>
</form>   
   </fieldset>
   <fieldset>
   <legend><?php _e('Instructions') ?></legend>
<p><strong>1. What this plugin does</strong></p>
It offers you two functions that you can add to your template: get_recent_comments() and get_recent_trackbacks(). They fetch the most recent comments or most recent trackbacks/pingbacks from the database and display them in a configurable formatting. The formatting is configured by two templates that use a number of macros. The macros are replaced by the acutal content in the output.

<p><strong>2. Adding the Plugin to the WordPress Template</strong></p>

<p>
You need to insert one of the following  code snippets into the sidebar template. Which one is the right depends on the <a href="themes.php">theme</a> you are using.
</p>

<em>Default Theme:</em> <span class="code">wp-content/themes/default/sidebar.php</span>
<div style="border: 1px solid; border-color: #ccc; margin: 15px; background: #eee;">
<pre class="code">
   &lt;?php if (function_exists('get_recent_comments')) { ?&gt;
   &lt;li&gt;&lt;h2&gt;&lt;?php _e('Recent Comments:'); ?&gt;&lt;/h2&gt;
        &lt;ul&gt;
        &lt;?php get_recent_comments(); ?&gt;
        &lt;/ul&gt;
   &lt;/li&gt;
   &lt;?php } ?&gt;   

   &lt;?php if (function_exists('get_recent_trackbacks')) { ?&gt;
   &lt;li&gt;&lt;h2&gt;&lt;?php _e('Recent Trackbacks:'); ?&gt;&lt;/h2&gt;
        &lt;ul&gt;
        &lt;?php get_recent_trackbacks(); ?&gt;
        &lt;/ul&gt;
   &lt;/li&gt;
   &lt;?php } ?&gt;
</pre>
</div>

<em>Classic Theme:</em> <span class="code">wp-content/themes/classic/sidebar.php</span>
<div style="border: 1px solid; border-color: #ccc; margin: 15px; background: #eee;">
<pre class="code">
   &lt;?php if (function_exists('get_recent_comments')) { ?&gt;
   &lt;li&gt;&lt;?php _e('Recent Comments:'); ?&gt;
        &lt;ul&gt;
        &lt;?php get_recent_comments(); ?&gt;
        &lt;/ul&gt;
   &lt;/li&gt;
   &lt;?php } ?&gt;

   &lt;?php if (function_exists('get_recent_trackbacks')) { ?&gt;
   &lt;li&gt;&lt;?php _e('Recent Trackbacks:'); ?&GT;
        &lt;ul&gt;
        &lt;?php get_recent_trackbacks(); ?&gt;
        &lt;/ul&gt;
   &lt;/li&gt;
   &lt;?php } ?&gt;
</pre>
</div>
<p><strong>3. Using the Macros</strong></p>
<table>
<tr><td valign="top">%comment_excerpt</td><td>The text of the comment. It might get shorted to the number of characters you entered in <em>"Long comments are chopped off at..."</em></td></tr>
<tr><td valign="top">%comment_link</td><td>The URL to the cited comment.</td></tr> 
<tr><td valign="top">%comment_author</td><td>The name, the commenter entered in the comment form. If she left the field empty, the name is "Anonymous".</td></tr>
<tr><td valign="top">%comment_date</td><td>The date, when the comment was posted in the style you configured as <a href="options-general.php">default date format</a>.</td></tr>
<tr><td valign="top">%comment_time</td><td>The time, when the comment was posted</td></tr>
<tr><td valign="top">%author_url</td><td>The URL, the comment author left in the comment form, or if the comment is a trackback, the URL of the site that issued the trackback.</td></tr>
<tr><td valign="top">%post_title</td><td>The title of the posting that was commented.</td></tr>
<tr><td valign="top">%post_link</td><td>The URL of the posting that was commented.</td></tr> 
<tr><td valign="top">%post_date</td><td>The date when the commented posting was published.</td></tr>
<tr><td valign="top">%trackback_title</td><td>Only applicable in trackbacks: The title of the trackback. It  might get shorted to the number of characters you entered in <em>"Long trackbacks are chopped off at..."</em></td></tr>
</table>

<p><strong>4. Miscellaneous</strong></p>
<ul>
<li>The path to the sidebar.php file may differ from the above examples if you installed a localized version of WordPress.</li>
<li>It is hard to extract title and content from pingbacks. Please contact the <a href="http://blog.jodies.de/archiv/2004/11/13/recent-comments/">author</a> if you are getting weird results.</li>
<li>The plugin treats trackbacks and pingbacks different than comments. Older versions of the plugin (and WordPress) made no difference between comments an trackbacks.</li>
<li>Pingbacks are also shown as Trackbacks.</li>
<li>Don't worry if you screwed up the template, reset the template to default and try again.</li>
<li>If you are used to an old (pre WordPress 1.5) version of the plugin, you will asked yourself, what happend to the configurable arguments in the get_recent_comments() function call. They are ignored now. You can delete them.</li>
<li><em>"Wrap long words at..."</em> means: Cited words, that exceed this length are split into fragments to prevent damage to the layout of your blog.</li>
</ul>
   </fieLDset>
</div>  


<?php 
}
else {
	function kjgrc_options_page() {
		add_options_page('Get Recent Comments Plugin', 'Recent Comments', 10, 'get-recent-comments.php');
	}

	function kjgrc_get_option($section,$option_name)
	{
		add_option('kjgrc_grc_max_comments',5);
		add_option('kjgrc_grc_chars_per_comment',120);
		add_option('kjgrc_grc_chars_per_word',30);
		add_option('kjgrc_grc_format',
                 '<li><a href="%comment_link" title="%post_title, %post_date">%comment_author</a>: %comment_excerpt</li>');

		add_option('kjgrc_grt_max_comments',5);
		add_option('kjgrc_grt_chars_per_comment',120);
		add_option('kjgrc_grt_chars_per_word',30);
		add_option('kjgrc_grt_format',
		'<li><a href="%comment_link" title="Trackback to &quot;%post_title&quot;: %comment_excerpt">%comment_author</a>: %trackback_title</li>');
		$option = get_option("kjgrc_" . $section . "_" . $option_name);
		return $option;
	}
  	
        if (function_exists('get_recent_trackbacks')) {
           echo "<strong>Warning: You have multiple plugins with a function &quot;get_recent_trackbacks()&quot;</strong>";
           return;
        }

  	function get_recent_trackbacks($sample=0)
	{
		global $tablecomments,$tableposts;
	
		// Be compatible to WordPress 1.2.x 
	        if (function_exists("is_plugin_page")) {
			$max_comments = kjgrc_get_option("grt","max_comments");
			$chars_per_comment = kjgrc_get_option("grt","chars_per_comment");
			$chars_per_word = kjgrc_get_option("grt","chars_per_word");
			$format = stripslashes(kjgrc_get_option("grt","format"));
			$COMMENT_TYPE = "AND comment_type = '' ";
	        } else {
			$COMMENT_TYPE = '';
			$chars_per_word = 30;
	        }
  
		if ($sample == 1) {
			$max_comments = 1;
			$echo = 0;
		} else {
			$echo = 1;
		}

		$query = "SELECT * FROM $tablecomments ".
			"LEFT JOIN $tableposts ON $tableposts.ID=$tablecomments.comment_post_ID ".
			"WHERE post_status = 'publish' AND comment_approved= '1' AND  post_password = '' ".
			"AND ( comment_type = 'trackback' OR COMMENT_TYPE = 'pingback' ) ".
			"ORDER BY comment_date DESC LIMIT $max_comments";
		return kjgrc_get_entries($max_comments,$chars_per_comment,$chars_per_word,$format,$query,$echo);	
	}

        if (function_exists('get_recent_comments')) {
           echo "<strong>Warning: You have multiple plugins with a function &quot;get_recent_comments()&quot;</strong>";
           return;
        }

	function get_recent_comments ($max_comments=5,
					$chars_per_comment=120,
	$format='<li><a href="%comment_link" title="%post_title, %post_date">%comment_author</a>: %comment_excerpt</li>',$sample=0) {
		global $tablecomments,$tableposts;

		// Be compatible to WordPress 1.2.x 
	        if (function_exists("is_plugin_page")) {
			$max_comments = kjgrc_get_option("grc","max_comments");
			$chars_per_comment = kjgrc_get_option("grc","chars_per_comment");
			$chars_per_word = kjgrc_get_option("grc","chars_per_word");
			$format = stripslashes(kjgrc_get_option("grc","format"));
			$COMMENT_TYPE = "AND comment_type = '' ";
	        } else {
			$COMMENT_TYPE = '';
			$chars_per_word = 30;
	        }  
		if ($sample == 1) {
			$max_comments = 1;
			$echo = 0;
		} else {
			$echo = 1;
		}
	
		$query = "SELECT * FROM $tablecomments ".
			"LEFT JOIN $tableposts ON $tableposts.ID=$tablecomments.comment_post_ID ".
			"WHERE post_status = 'publish' AND comment_approved= '1' AND  post_password = '' ".
			$COMMENT_TYPE .
			"ORDER BY comment_date DESC LIMIT $max_comments";
		return kjgrc_get_entries($max_comments,$chars_per_comment,$chars_per_word,$format,$query,$echo);
	}

	function kjgrc_get_entries ($max_comments,$chars_per_comment,$chars_per_word,
						$format,$query,$echo=1)
	{
		global $wpdb;
		$comments = $wpdb->get_results($query);
	        if (! $comments) {
			echo "<li></li>";
			return;
		}
		foreach ($comments as $comment)
		{
			$trackback_title = '';
			$comment_excerpt = $comment->comment_content;
			if (function_exists("is_plugin_page")) // be compatible to wp 1.2.x
			{
				if ($comment->comment_type == 'pingback') {
					$trackback_title = $comment->comment_author;
					if (strpos($trackback_title,'&raquo;')) {
						$trackback_title = substr($trackback_title,
                                        	strpos($trackback_title,'&raquo;')+7,strlen($trackback_title));
					}
					if (strpos($trackback_title,'&raquo;')) {
						$trackback_title = substr($trackback_title,
                                        	strpos($trackback_title,'&raquo;')+7,strlen($trackback_title));
					}
					//$trackback_title .= " '$comment->comment_author [P]'";
					//$trackback_title = "Pingback";
				}
				elseif ($comment->comment_type == 'trackback') {
					$trackback_title = preg_replace("/^<strong>(.+?)<\/strong>.*/s","$1",$comment->comment_content);
					$trackback_title = strip_tags($trackback_title);
					$trackback_title = preg_replace("/[\n\t\r]/"," ",$trackback_title);
	                	        $trackback_title = preg_replace("/\s{2,}/"," ",$trackback_title);
	                	        $trackback_title = wordwrap($trackback_title,$chars_per_word,' ',1);
													
					$comment_excerpt = preg_replace("/^<strong>.+?<\/strong>/","",$comment->comment_content,1);
					
					$comment_excerpt = strip_tags($comment_excerpt); //trackbacks need htmlspecialchars. strip
											 //must come before 
					$comment_excerpt = htmlspecialchars($comment_excerpt);
				}
			}
			$comment_excerpt = strip_tags($comment_excerpt);

			$comment_excerpt = preg_replace("/[\n\t\r]/"," ",$comment_excerpt);
			$comment_excerpt = preg_replace("/\s{2,}/"," ",$comment_excerpt);
	                $comment_excerpt = wordwrap($comment_excerpt,$chars_per_word,' ',1);
	                
			$post_link    = get_permalink($comment->comment_post_ID);
			$comment_link = $post_link .
					"#comment-$comment->comment_ID";
			$comment_date = mysql2date(get_settings('date_format'),$comment->comment_date);
			$comment_time = substr($comment->comment_date,11,5); // 2005-03-09 22:23:53
			$comment_author = $comment->comment_author;
			if ($comment->comment_type == 'pingback') {

				$comment_author = trim(substr($comment_author,0,strpos($comment_author,'&raquo;')));
			}
			if (! $comment_author) $comment_author = 'Anonymous';
			$post = get_postdata($comment->comment_post_ID);
			$post_date = mysql2date(get_settings('date_format'),$post['Date']);
	
			$output = $format;
			$output = str_replace("%comment_link",    $comment_link,   $output);
			$output = str_replace("%author_url",      $comment->comment_author_url, $output);
			$output = str_replace("%comment_author",  $comment_author, $output);
			$output = str_replace("%comment_date",    $comment_date,   $output);
			$output = str_replace("%comment_time",    $comment_time,   $output);
			$output = str_replace("%post_title",      
	                                       trim(htmlspecialchars(stripslashes($post['Title']))), $output);
			$output = str_replace("%post_link",       $post_link,      $output);
			$output = str_replace("%post_date",       $post_date,      $output);

			//strip title or content?
			$visible = strip_tags($output);
			#$output .= "[[$visible]]";
			if (strpos($visible,'%comment_excerpt')) {
				$comment_excerpt = kjgrc_excerpt($comment_excerpt,$chars_per_comment,$chars_per_word,'%comment_excerpt',$output);
			} 
			elseif (strpos($visible,'%trackback_title')) {
				$trackback_title = kjgrc_excerpt($trackback_title,$chars_per_comment,$chars_per_word,'%trackback_title',$output);
			}
			
			
			#$comment_excerpt = kjgrc_excerpt($comment_excerpt,$len,$chars_per_word);
			#$trackback_title = kjgrc_excerpt($trackback_title,$len,$chars_per_word);
			$output = str_replace("%comment_excerpt", $comment_excerpt,$output);
			$output = str_replace("%trackback_title",   $trackback_title,  $output);
			#$len = strlen(strip_tags($output));
			//$output .= " [$comment_time]";
			if (! $echo) {
	                	return "$output"; 
			} else {
	                	echo "\t$output\n"; 
			}
		}
	}

	function kjgrc_excerpt ($text,$chars_per_comment,$chars_per_word,$tag,$output)
	{
			
		$length = strlen(str_replace($tag,"",strip_tags($output)));
		$length = $chars_per_comment - $length;
		$length = $length -2; // we will add three dots at the end
		if ($length < 0) $length = 0;
		if (strlen($text) > $length) {
			$text = substr($text,0,$length);
			$text = substr($text,0,strrpos($text,' '));
			// last word exceeds max word length:
			if ((strlen($text) - strrpos($text,' ')) > $chars_per_word) {
				$text = substr($text,0,strlen($text)-3);
			} 
			$text = $text . "...";
		}
		return "$text";
	}
}

add_action('admin_menu', 'kjgrc_options_page');
?>
